/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUSBuǗ܂B
//!
//! USBƂUSBνĂ̐Vv̓𒲂ׂ܂B
//! \ݒ(SETUP)vNƁA̍Ƃusb_standard_request.çقɊ܂܂
//! 邱̍\ݒ̏Jn܂B
//! ̸׽Lv̧قŏ܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB1287, AT90USB1286, AT90USB647, AT90USB646
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_device_task.h"
#include "modules/usb/usb_task.h"
#if (USB_OTG_FEATURE == ENABLED)
  #include "modules/usb/host_chap9/usb_host_task.h"
#endif
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "lib_mcu/pll/pll_drv.h"

#if ((TARGET_BOARD==SPIDER) && (USB_OTG_FEATURE==ENABLED))
  #include "lib_board/lcd/lcd_drv.h"
#endif

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

//!
//! J: (bit) usb_connected
//! usb_connectedVBUSoꂽTRUEɐݒ肳܂B
//! usb_connected͂ȂFALSEɐݒ肳܂B
//!/
bit usb_connected=FALSE;

//!
//! J: (bit) usb_suspended
//! usb_suspendedUSBx~()`Ԃ̎TRUEɐݒ肳܂B
//! usb_suspended͂ȂFALSEɐݒ肳܂B
//!/
bit usb_suspended=FALSE;

//!
//! J: (U8) usb_configuration_nb
//! USBuɂĎgpUSB`Ԑݒ萔i[܂B
//! ̒l0ƈقȂ鎞ɂ͑u`Ԃ(ڑF)ꂽƂӖ܂B
//! USB_DEVICE_FEATURE == ENABLEDłgp܂B
//!/
extern U8 usb_configuration_nb;

#if (USB_OTG_FEATURE == ENABLED)
//! J: (U8) otg_b_device_state;
//! B-ǔ݂̏Ԃi[܂B
U8 otg_b_device_state;

//! J: (U8) otg_device_sessions;
//! OTGuƂw肷邢̎ۂƏi[܂B
U8 otg_device_sessions;

//! J: (U8) otg_b_device_hnp;
//! OTG B-uHNPKw肷邢̎ۂƏi[܂B
U8 otg_b_device_hnp;

//! J: (U16) otg_tb_srp_cpt;
//! SRPsԂ}̂Ɏgpv(Tb_Srp_Failo߂̏ꍇSRPs)
U16 otg_tb_srp_cpt;

//! J: (U8) sof_seen_in_session;
//! ݂̍ƒSOFvMꂽꍇ܂B
//!/
U8 sof_seen_in_session;
#endif

//_____ 錾 _______________________________________________________________

//!
//! @brief ̊֐USBuƼъ荞݂܂B
//!
//! ̊֐USBUSB荞݂܂B
//! _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
//!/
void usb_device_task_init (void)
{
	Enable_interrupt();
	Usb_disable();
	Usb_enable();
	Usb_select_device();
#if (USB_LOW_SPEED_DEVICE==ENABLE)
	Usb_low_speed_mode();
#endif
	Enable_interrupt();
#if (USB_OTG_FEATURE == ENABLED)
	Usb_enable_id_interrupt();
	Clear_otg_features_from_host();
	otg_device_sessions = 0;
#endif
}

//!
//! @brief ̊֐USBu܂B
//!
//! ̊֐USBUSB荞݂܂B
//! _͓`ԊǗɓK؂USBۂ𑗂邽߂USBڑoƂłB
//! u@\̊JnVBUSω荞݂܂VBUSHighق̂ǂ炩ɂĈU
//! VBUSڑoƎs܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_start_device (void)
{
	Pll_start_auto();
	Wait_pll_ready();

	Disable_interrupt();
	Usb_unfreeze_clock();
	usb_init_device();						// USB߲0`Ԑݒ
	Usb_attach();
	Enable_interrupt();

	Usb_enable_suspend_interrupt();
	Usb_enable_reset_interrupt();
#if (USB_OTG_FEATURE == ENABLED)
	Usb_enable_id_interrupt();
#endif
}

//! @brief USBuǗ̓_
//!
//! ̊֐USBǗ̓_łBeUSBۂ͓K؂ȊJn邽߂ɂ
//! ׂ܂B萧߲Ăō\ݒ(SETUP)vNꍇA
//! usb_process_request()֐usb_standard_request.çٓĂт܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
void usb_device_task (void)
{
#if (USB_OTG_FEATURE == ENABLED)
	// ؾĂ󂯎ꂽ
	if(Is_usb_event(EVT_USB_RESET))
	{
		Usb_ack_event(EVT_USB_RESET);
		Usb_reset_endpoint(0);
		usb_configuration_nb=0;
		otg_b_device_state = B_IDLE;
		Clear_otg_features_from_host();
	}

	// OTG싖AB-u͂̏ԋ@\ɂĊǗ܂B
	switch (otg_b_device_state)
	{
		//------------------------------------------------------
	// B_IDLE
	//
	// - VBUS㏸ҋ@
	// - gp҂ɂĖꂽꍇSRP
		//
		case B_IDLE:
			if (Is_usb_vbus_high())
			{
				// VBUS㏸
				usb_connected = TRUE;
				remote_wakeup_feature = DISABLED;
				usb_start_device();
				Usb_vbus_on_action();
				Usb_attach();
				otg_b_device_state = B_PERIPHERAL;
				Ack_user_request_srp();
				Clear_otg_features_from_host();
				remote_wakeup_feature = DISABLED;
				End_session_with_srp();
				if (Is_srp_sent_and_waiting_answer() && (sof_seen_in_session == TRUE))
				{
					Ack_srp_sent_and_answer();
					Otg_print_new_failure_message(OTGMSG_A_RESPONDED,OTG_TEMPO_2SEC);
				}
				Usb_enable_sof_interrupt();
			}
			else
			{
				if (Is_user_requested_srp() && Is_usb_id_device())
				{
					// gp҂SRPv
					Ack_user_request_srp();
					if (!Is_srp_sent_and_waiting_answer())
					{
						Pll_start_auto();	// u`ԍď
						Wait_pll_ready();
						Usb_disable();
						Usb_enable_uid_pin();
						Usb_enable();
						Usb_unfreeze_clock();
						Usb_select_device();
						Usb_attach();
						otg_b_device_state = B_SRP_INIT;
						Usb_device_initiate_srp();		// ʰ޳ԑ҂(SE0,ƏI)
						sof_seen_in_session = FALSE;
					}
				}
				if ((Is_srp_sent_and_waiting_answer()) && (Is_tb_srp_counter_overflow()))
				{
					// A-uȂ߂SRPs
					End_session_with_srp();
					Ack_srp_sent_and_answer();
						Otg_print_new_failure_message(OTGMSG_SRP_A_NO_RESP,OTG_TEMPO_3SEC);
				}
			}
			break;

		//------------------------------------------------------
		// B_SRP_INIT
		//
		// - SRP܂B
		// - B-u͕ϐ邽߂ɂꂪI҂܂B
		//
		case B_SRP_INIT:
			if (!Is_usb_device_initiating_srp())
			{
				otg_b_device_state = B_IDLE;	// SRPA(VBUS㏸ҋ@)ԂԂ܂B
				Srp_sent_and_waiting_answer();
				Init_tb_srp_counter();
				Start_session_with_srp();
				Otg_print_new_event_message(OTGMSG_SRP_STARTED,TB_SRP_FAIL_MIN);
			}
		break;

		//------------------------------------------------------
		// B_PERIPHERAL : OTGӋ@\̎
		//
		// - Sۂ͊荞݂ŏ܂B
		// - ͕ۑÅ֐͑֊s邱Ƃł܂B
		// - gpҗv(ؒf)܂B
		//
		// ======================================================================================
		case B_PERIPHERAL:
			if (Is_otg_event(EVT_OTG_DEVICE_CONNECTED))
			{
				Otg_ack_event(EVT_OTG_DEVICE_CONNECTED);	// SetConfigurationLqqMŐݒ
				Otg_print_new_event_message(OTGMSG_CONNECTED_TO_A,OTG_TEMPO_4SEC);
			}
			if (Is_usb_event(EVT_USB_SUSPEND))	// x~(SUSPEND)
			{
				// x~(Suspend)HNP͊荞݊֐ŏ܂B
			}
			if (Is_srp_sent_and_waiting_answer() && (sof_seen_in_session == TRUE))
			{
				Ack_srp_sent_and_answer();
				Otg_print_new_failure_message(OTGMSG_A_RESPONDED,OTG_TEMPO_2SEC);
			}
			if ((Is_srp_sent_and_waiting_answer()) && (Is_tb_srp_counter_overflow())) 
			{
				// A-uȂ߂SRPs
				End_session_with_srp();
				Ack_srp_sent_and_answer();
				Otg_print_new_failure_message(OTGMSG_SRP_A_NO_RESP,OTG_TEMPO_3SEC);
			}

			if (Is_usb_event(EVT_USB_RESUME) && !Is_usb_pending_remote_wake_up())	// ĊJ(RESUME)Mo
			{
				Usb_ack_event(EVT_USB_RESUME);
				Usb_ack_event(EVT_USB_SUSPEND);
				Usb_ack_remote_wake_up_start();
			}
			if (Is_usb_event(EVT_USB_UNPOWERED))
			{
				Usb_ack_event(EVT_USB_UNPOWERED);
				Clear_all_user_request();
				otg_b_device_state = B_IDLE;
			}
			if(Is_usb_event(EVT_USB_RESET))
			{
				Usb_ack_event(EVT_USB_RESET);
				Usb_reset_endpoint(0);
				usb_configuration_nb=0;
				Clear_otg_features_from_host();
			}
			if (Is_otg_event(EVT_OTG_HNP_ERROR))
			{
				Otg_ack_event(EVT_OTG_HNP_ERROR);
				Otg_print_new_failure_message(OTGMSG_DEVICE_NO_RESP,OTG_TEMPO_4SEC);
				PORTC &= ~0x10;
			}
			if (Is_user_requested_disc())
			{
				Ack_user_request_disc();
				if (Is_usb_id_device())
				{
					Usb_detach();
					Usb_freeze_clock();
					while (Is_usb_vbus_high());	// Va_vbus_validȉVBUSҋ@
					otg_b_device_state = B_IDLE;
					usb_configuration_nb = 0;
					usb_connected = FALSE;
					Clear_all_user_request();
				}
			}
			break;

		//------------------------------------------------------
		// B_HOST
		//
		// - HNPɈڍs
		// - gpҗv(ؒfAx~AHNP)
		// - ν ُ̂߂"host_task()"Ăяo
		//
		// ======================================================================================
		case B_HOST:
			if (Is_otg_event(EVT_OTG_DEV_UNSUPPORTED))
			{
				Otg_ack_event(EVT_OTG_DEV_UNSUPPORTED);
				Clear_all_user_request();
				otg_b_device_state = B_IDLE;
				device_state = DEVICE_UNATTACHED;
			}
			if (Is_user_requested_disc() || Is_user_requested_suspend() || Is_user_requested_hnp())
			{
				Ack_user_request_disc();	// x~(Suspend)HNPvB_END_HNP_SUSPENDiŉ܂B
				Host_disable_sof();			// x~(Suspend)`Ԃ֍sB
				Usb_host_reject_hnp();
				otg_b_device_state = B_END_HNP_SUSPEND;
				Usb_ack_suspend();
				Usb_enable_suspend_interrupt();
			}
			if (Is_usb_event(EVT_USB_UNPOWERED))
			{
				Usb_ack_event(EVT_USB_UNPOWERED);
				Usb_freeze_clock();
				otg_b_device_state = B_IDLE;
				device_state = DEVICE_UNATTACHED;
			}
			usb_host_task();				// νčƌĂяo
			break;

		//------------------------------------------------------
		// B_END_HNP_SUSPEND
		//
		// - u޽~(x~(Suspend)AؒfA܂HNPv)̂߂̎gpҗvB_HOSTɂȂł̏Ԃֈڍs܂B
		// - ϸۂӋ@\`ԂؾĂ܂B
		//
		// ======================================================================================
		case B_END_HNP_SUSPEND:
			if (Is_usb_event(EVT_USB_SUSPEND))
			{
				Usb_ack_event(EVT_USB_SUSPEND);
				Usb_device_stop_hnp();
				Usb_select_device();
				device_state = DEVICE_UNATTACHED;
				if (Is_user_requested_hnp() || Is_user_requested_suspend())
				{
					otg_b_device_state = B_PERIPHERAL;
					Ack_user_request_suspend();
					Ack_user_request_hnp();
				}
				else
				{
					otg_b_device_state = B_IDLE;
					Usb_detach();
					Usb_freeze_clock();
				}
			}
			break;

		default:
			otg_b_device_state = B_IDLE;
			Clear_all_user_request();
			device_state = DEVICE_UNATTACHED;
			break;
	}
#else
	// OTGru

	// VBUSԌo
	if (Is_usb_vbus_high()&& (usb_connected==FALSE))
	{
		usb_connected = TRUE;
		remote_wakeup_feature = DISABLED;
		Usb_vbus_on_action();
		Usb_send_event(EVT_USB_POWERED);
		usb_start_device();
	}
	if (Is_usb_vbus_low()&& (usb_connected==TRUE))
	{
		usb_connected = FALSE;
		usb_configuration_nb = 0;
		Usb_send_event(EVT_USB_UNPOWERED);
		Usb_detach();
		Usb_freeze_clock();
		Usb_vbus_off_action();
	}

	if(Is_usb_event(EVT_USB_RESET))
	{
		Usb_ack_event(EVT_USB_RESET);
		Usb_reset_endpoint(0);
		usb_configuration_nb=0;
	}
#endif

	// ====================
	// ʕWuv
	// ====================
	// - u(ڑF)
	// - u䖽߂Ƌ@\
	Usb_select_endpoint(EP_CONTROL);
	if (Is_usb_receive_setup())
	{
		usb_process_request();
	}
}
